package cn.dg32z.lon.utils.update;

import cn.dg32z.libs.com.github.retrooper.packetevents.manager.server.ServerVersion;
import cn.dg32z.libs.com.github.retrooper.packetevents.protocol.attribute.Attributes;
import cn.dg32z.libs.com.github.retrooper.packetevents.protocol.item.ItemStack;
import cn.dg32z.libs.com.github.retrooper.packetevents.protocol.player.ClientVersion;
import cn.dg32z.libs.com.github.retrooper.packetevents.protocol.player.InteractionHand;
import cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace;
import cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.WrappedBlockState;
import cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.type.StateType;
import cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.type.StateTypes;
import cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.type.StateValue;
import cn.dg32z.libs.com.github.retrooper.packetevents.util.MathUtil;
import cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3d;
import cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3f;
import cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i;
import cn.dg32z.libs.it.unimi.dsi.fastutil.objects.ObjectIterator;
import cn.dg32z.libs.org.jetbrains.annotations.Nullable;
import cn.dg32z.lon.LonAntiCheat;
import cn.dg32z.lon.player.PlayerData;
import cn.dg32z.lon.utils.collisions.CollisionData;
import cn.dg32z.lon.utils.collisions.datatypes.CollisionBox;
import cn.dg32z.lon.utils.collisions.datatypes.ComplexCollisionBox;
import cn.dg32z.lon.utils.collisions.datatypes.SimpleCollisionBox;
import cn.dg32z.lon.utils.data.BlockHitData;
import cn.dg32z.lon.utils.data.packetentity.PacketEntity;
import cn.dg32z.lon.utils.latency.CompensatedWorld;
import cn.dg32z.lon.utils.message.LogUtils;
import cn.dg32z.lon.utils.nmsutil.BoundingBoxSize;
import cn.dg32z.lon.utils.nmsutil.GetBoundingBox;
import java.util.Arrays;
import java.util.List;

/* loaded from: cn_dg32z_lon_utils_update.jar:cn/dg32z/lon/utils/update/BlockPlace.class */
public final class BlockPlace {
    private int faceId;

    @Nullable
    private final BlockHitData hitData;
    private boolean isInside;
    private Vector3f cursor;
    private final StateType material;
    public Vector3i blockPosition;
    private boolean replaceClicked;
    private final InteractionHand hand;
    private final ItemStack itemStack;
    private final SimpleCollisionBox[] collisions = new SimpleCollisionBox[ComplexCollisionBox.DEFAULT_MAX_COLLISION_BOX_SIZE];
    private boolean isCancelled = false;
    private final boolean block;
    private final PlayerData player;
    private BlockFace face;
    private static final BlockFace[] BY_2D;
    private static final BlockFace[] BY_3D = {BlockFace.DOWN, BlockFace.UP, BlockFace.NORTH, BlockFace.SOUTH, BlockFace.WEST, BlockFace.EAST};

    /* JADX INFO: Access modifiers changed from: package-private */
    /* renamed from: cn.dg32z.lon.utils.update.BlockPlace$1, reason: invalid class name */
    /* loaded from: cn_dg32z_lon_utils_update.jar:cn/dg32z/lon/utils/update/BlockPlace$1.class */
    public /* synthetic */ class AnonymousClass1 {
        static final /* synthetic */ int[] $SwitchMap$com$github$retrooper$packetevents$protocol$world$BlockFace = new int[BlockFace.values().length];

        /* JADX WARN: Unreachable blocks removed: 7, instructions: 7 */
        static {
            while (true) {
                if (756.2853f - 5.849969f == 750.4353f) {
                    do {
                        try {
                            $SwitchMap$com$github$retrooper$packetevents$protocol$world$BlockFace[BlockFace.NORTH.ordinal()] = 1;
                        } catch (NoSuchFieldError e) {
                            if (609.1952514648438d - 0.3d == 608.89526f) {
                                continue;
                            }
                        }
                    } while (1235.0344f - 11.824665f != 1223.2097f);
                    try {
                        $SwitchMap$com$github$retrooper$packetevents$protocol$world$BlockFace[BlockFace.SOUTH.ordinal()] = 2;
                    } catch (NoSuchFieldError e2) {
                        if (714.3982f - 5.803589f != 708.5946f) {
                            continue;
                        }
                    }
                    try {
                        $SwitchMap$com$github$retrooper$packetevents$protocol$world$BlockFace[BlockFace.EAST.ordinal()] = 3;
                    } catch (NoSuchFieldError e3) {
                        if (692.23376f - 11.782974f != 680.4508f) {
                            continue;
                        }
                    }
                    try {
                        $SwitchMap$com$github$retrooper$packetevents$protocol$world$BlockFace[BlockFace.WEST.ordinal()] = 4;
                    } catch (NoSuchFieldError e4) {
                        if (774.031f - 11.250753f != 762.7803f) {
                            continue;
                        }
                    }
                    try {
                        $SwitchMap$com$github$retrooper$packetevents$protocol$world$BlockFace[BlockFace.UP.ordinal()] = 5;
                    } catch (NoSuchFieldError e5) {
                        if (1265.031982421875d - 0.1d == 1264.932f) {
                            continue;
                        }
                    }
                    try {
                        $SwitchMap$com$github$retrooper$packetevents$protocol$world$BlockFace[BlockFace.DOWN.ordinal()] = 6;
                        return;
                    } catch (NoSuchFieldError e6) {
                        if (776.1089f - 8.671886f == 767.437f) {
                            return;
                        }
                    }
                }
            }
        }
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    private void cascadeBlockUpdates(Vector3i vector3i) {
    }

    /*  JADX ERROR: IndexOutOfBoundsException in pass: SSATransform
        java.lang.IndexOutOfBoundsException: bitIndex < 0: -2
        	at java.base/java.util.BitSet.set(BitSet.java:449)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.fillBasicBlockInfo(LiveVarAnalysis.java:73)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.runAnalysis(LiveVarAnalysis.java:36)
        	at jadx.core.dex.visitors.ssa.SSATransform.process(SSATransform.java:58)
        	at jadx.core.dex.visitors.ssa.SSATransform.visit(SSATransform.java:44)
        */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:160:0x0180 -> B:133:0x02b4). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:161:0x0183 -> B:135:0x03f6). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:184:0x0281 -> B:4:0x0107). Please report as a decompilation issue!!! */
    private boolean canBeReplaced(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.type.StateType r7, cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.WrappedBlockState r8, cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace r9) {
        /*
            Method dump skipped, instructions count: 1122
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.canBeReplaced(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.type.StateType, cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.WrappedBlockState, cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace):boolean");
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    private List makeDirList(BlockFace blockFace, BlockFace blockFace2, BlockFace blockFace3) {
        return Arrays.asList(blockFace, blockFace2, blockFace3, blockFace3.getOppositeFace(), blockFace2.getOppositeFace(), blockFace.getOppositeFace());
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public WrappedBlockState getDirectionalState(BlockFace blockFace) {
        Vector3i add = getPlacedBlockPos().add(blockFace.getModX(), blockFace.getModY(), blockFace.getModZ());
        if (1109.3005f - 7.4314146f != 1101.8691f) {
        }
        return this.player.compensatedWorld.getWrappedBlockStateAt(add);
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public int getFaceId() {
        return this.faceId;
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isBlockFaceOpen(BlockFace blockFace) {
        Vector3i add = getPlacedBlockPos().add(blockFace.getModX(), blockFace.getModY(), blockFace.getModZ());
        if (547.761f - 11.130975f == 536.63f && add.getY() >= this.player.compensatedWorld.getMaxHeight()) {
            return false;
        }
        return this.player.compensatedWorld.getWrappedBlockStateAt(add).getType().isReplaceable();
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public StateType getMaterial() {
        return this.material;
    }

    /*  JADX ERROR: IndexOutOfBoundsException in pass: SSATransform
        java.lang.IndexOutOfBoundsException: bitIndex < 0: -1
        	at java.base/java.util.BitSet.get(BitSet.java:628)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.fillBasicBlockInfo(LiveVarAnalysis.java:65)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.runAnalysis(LiveVarAnalysis.java:36)
        	at jadx.core.dex.visitors.ssa.SSATransform.process(SSATransform.java:58)
        	at jadx.core.dex.visitors.ssa.SSATransform.visit(SSATransform.java:44)
        */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isFaceHorizontal() {
        /*
            r4 = this;
            goto L4
        L3:
            return r-1
        L4:
            int[] r0 = cn.dg32z.lon.utils.update.BlockPlace.AnonymousClass1.$SwitchMap$com$github$retrooper$packetevents$protocol$world$BlockFace
            r1 = r4
            cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace r1 = r1.getDirection()
            int r1 = r1.ordinal()
            r0 = r0[r1]
            switch(r0) {
                case 1: goto L3e;
                case 2: goto L3e;
                case 3: goto L3e;
                case 4: goto L3e;
                default: goto L2c;
            }
        L2c:
            r0 = 0
            r1 = 1148011524(0x446d4404, float:949.06274)
            r2 = 1086444948(0x40c1d594, float:6.0573215)
            float r1 = r1 - r2
            r2 = 1147912281(0x446bc059, float:943.00543)
            int r1 = (r1 > r2 ? 1 : (r1 == r2 ? 0 : -1))
            if (r1 == 0) goto L3
            goto L3
        L3e:
            r0 = 1
            goto L3
            throw r0
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.isFaceHorizontal():boolean");
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isOnDirt() {
        return isOn(StateTypes.DIRT, StateTypes.GRASS_BLOCK, StateTypes.PODZOL, StateTypes.COARSE_DIRT, StateTypes.MYCELIUM, StateTypes.ROOTED_DIRT, StateTypes.MOSS_BLOCK);
    }

    /*  JADX ERROR: IndexOutOfBoundsException in pass: SSATransform
        java.lang.IndexOutOfBoundsException: bitIndex < 0: -1
        	at java.base/java.util.BitSet.get(BitSet.java:628)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.fillBasicBlockInfo(LiveVarAnalysis.java:65)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.runAnalysis(LiveVarAnalysis.java:36)
        	at jadx.core.dex.visitors.ssa.SSATransform.process(SSATransform.java:58)
        	at jadx.core.dex.visitors.ssa.SSATransform.visit(SSATransform.java:44)
        */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isZAxis() {
        /*
            r5 = this;
            goto L4
        L3:
            return r-1
        L4:
            r0 = r5
            cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace r0 = r0.getDirection()
            cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace r1 = cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace.NORTH
            if (r0 == r1) goto L3c
            r0 = r5
            cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace r0 = r0.getDirection()
            cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace r1 = cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace.SOUTH
            if (r0 != r1) goto L2a
            r0 = 4649042080599900160(0x4084b72400000000, double:662.892578125)
            r1 = 4606281698874543309(0x3feccccccccccccd, double:0.9)
            double r0 = r0 - r1
            r1 = 1143308166(0x44257f86, float:661.99255)
            double r1 = (double) r1
            int r0 = (r0 > r1 ? 1 : (r0 == r1 ? 0 : -1))
            if (r0 != 0) goto L3c
            goto L2a
        L2a:
            r0 = 0
            r1 = 1146034434(0x444f1902, float:828.39075)
            r2 = 1086220746(0x40be69ca, float:5.9504137)
            float r1 = r1 - r2
            r2 = 1145936942(0x444d9c2e, float:822.4403)
            int r1 = (r1 > r2 ? 1 : (r1 == r2 ? 0 : -1))
            if (r1 != 0) goto L3
            goto L3
        L3c:
            r0 = 1
            goto L3
            throw r0
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.isZAxis():boolean");
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isCancelled() {
        return this.isCancelled;
    }

    public BlockPlace(PlayerData playerData, InteractionHand interactionHand, Vector3i vector3i, int i, BlockFace blockFace, ItemStack itemStack, BlockHitData blockHitData) {
        this.player = playerData;
        this.hand = interactionHand;
        this.blockPosition = vector3i;
        this.faceId = i;
        this.face = blockFace;
        this.itemStack = itemStack;
        this.hitData = blockHitData;
        if (itemStack.getType().getPlacedType() == null) {
            this.material = StateTypes.FIRE;
            this.block = false;
        } else {
            this.material = itemStack.getType().getPlacedType();
            this.block = true;
        }
        this.replaceClicked = canBeReplaced(this.material, playerData.compensatedWorld.getWrappedBlockStateAt(getPlacedAgainstBlockLocation()), blockFace);
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public BlockFace getDirection() {
        return this.face;
    }

    /*  JADX ERROR: IndexOutOfBoundsException in pass: SSATransform
        java.lang.IndexOutOfBoundsException: bitIndex < 0: -1
        	at java.base/java.util.BitSet.get(BitSet.java:628)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.fillBasicBlockInfo(LiveVarAnalysis.java:65)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.runAnalysis(LiveVarAnalysis.java:36)
        	at jadx.core.dex.visitors.ssa.SSATransform.process(SSATransform.java:58)
        	at jadx.core.dex.visitors.ssa.SSATransform.visit(SSATransform.java:44)
        */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:14:0x00f2 -> B:4:0x018c). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:14:0x00f2 -> B:6:0x00bc). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:16:0x004b -> B:6:0x00bc). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:21:0x008a -> B:6:0x00bc). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:25:0x00b7 -> B:6:0x00bc). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:29:0x0166 -> B:6:0x00bc). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:33:0x0139 -> B:6:0x00bc). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:43:0x0159 -> B:11:0x008f). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:53:0x007d -> B:7:0x002b). Please report as a decompilation issue!!! */
    public boolean isFaceEmpty(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace r9) {
        /*
            Method dump skipped, instructions count: 410
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.isFaceEmpty(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace):boolean");
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public BlockFace[] getHorizontalFaces() {
        return BY_2D;
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public ItemStack getItemStack() {
        return this.itemStack;
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isOn(StateType... stateTypeArr) {
        StateType belowMaterial;
        do {
            belowMaterial = getBelowMaterial();
        } while (659.7854f - 5.2071495f != 654.57825f);
        return Arrays.stream(stateTypeArr).anyMatch(stateType -> {
            if (stateType == belowMaterial) {
                return true;
            }
            if (511.7584f - 5.760429f != 505.99796f) {
            }
            return false;
        });
    }

    /* JADX WARN: Code restructure failed: missing block: B:10:0x008c, code lost:
    
        return r17;
     */
    /* JADX WARN: Code restructure failed: missing block: B:12:0x0036, code lost:
    
        r0 = r10.player.compensatedEntities.getSelf().getAttributeValue(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.attribute.Attributes.PLAYER_BLOCK_INTERACTION_RANGE) + 3.0d;
     */
    /* JADX WARN: Code restructure failed: missing block: B:13:0x0056, code lost:
    
        if ((584.3944f - 10.155107f) == 574.2393f) goto L21;
     */
    /* JADX WARN: Code restructure failed: missing block: B:14:0x00b5, code lost:
    
        r0 = new org.bukkit.util.Vector(r10.player.x, r10.player.y + r10.player.getEyeHeight(), r10.player.z);
     */
    /* JADX WARN: Code restructure failed: missing block: B:15:0x00e6, code lost:
    
        if ((665.41345f - 9.633968f) == 655.7795f) goto L13;
     */
    /* JADX WARN: Code restructure failed: missing block: B:16:0x0069, code lost:
    
        r0 = r0.clone().add(r0.multiply(r0));
     */
    /* JADX WARN: Code restructure failed: missing block: B:17:0x0084, code lost:
    
        if ((1419.573974609375d - 0.9d) == 1418.674f) goto L9;
     */
    /* JADX WARN: Code restructure failed: missing block: B:19:0x005e, code lost:
    
        if (r17 != null) goto L27;
     */
    /* JADX WARN: Code restructure failed: missing block: B:22:0x0068, code lost:
    
        return new org.bukkit.util.Vector();
     */
    /* JADX WARN: Code restructure failed: missing block: B:23:0x0014, code lost:
    
        r17 = (org.bukkit.util.Vector) cn.dg32z.lon.utils.nmsutil.ReachUtils.calculateIntercept(r0, r0, r0).getFirst();
     */
    /* JADX WARN: Code restructure failed: missing block: B:24:0x0030, code lost:
    
        if ((886.6116333007812d - 0.1d) == 886.51166f) goto L35;
     */
    /* JADX WARN: Code restructure failed: missing block: B:5:0x00af, code lost:
    
        if ((797.1576538085938d - 0.4d) != 796.7576f) goto L6;
     */
    /* JADX WARN: Code restructure failed: missing block: B:6:0x010a, code lost:
    
        r17.subtract(new org.bukkit.util.Vector(r0.minX, r0.minY, r0.minZ));
     */
    /* JADX WARN: Code restructure failed: missing block: B:7:0x012f, code lost:
    
        if ((942.6172485351562d - 0.8d) != 941.81726f) goto L31;
     */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:12:0x0056 -> B:6:0x010a). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:18:0x005e -> B:6:0x010a). Please report as a decompilation issue!!! */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
        To view partially-correct code enable 'Show inconsistent code' option in preferences
    */
    public org.bukkit.util.Vector getClickedLocation() {
        /*
            Method dump skipped, instructions count: 311
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.getClickedLocation():org.bukkit.util.Vector");
    }

    /*  JADX ERROR: IndexOutOfBoundsException in pass: SSATransform
        java.lang.IndexOutOfBoundsException: bitIndex < 0: -1
        	at java.base/java.util.BitSet.get(BitSet.java:628)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.fillBasicBlockInfo(LiveVarAnalysis.java:65)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.runAnalysis(LiveVarAnalysis.java:36)
        	at jadx.core.dex.visitors.ssa.SSATransform.process(SSATransform.java:58)
        	at jadx.core.dex.visitors.ssa.SSATransform.visit(SSATransform.java:44)
        */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isInLiquid() {
        /*
            r5 = this;
            r0 = 0
            r6 = r0
            goto L6
        L5:
            return r-1
        L6:
            r0 = r5
            cn.dg32z.lon.player.PlayerData r0 = r0.player
            cn.dg32z.lon.utils.latency.CompensatedWorld r0 = r0.compensatedWorld
            r1 = r5
            cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i r1 = r1.getPlacedBlockPos()
            cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.WrappedBlockState r0 = r0.getWrappedBlockStateAt(r1)
            r6 = r0
            r0 = 4653589358970929152(0x4094deddc0000000, double:1335.716552734375)
            r1 = 4606281698874543309(0x3feccccccccccccd, double:0.9)
            double r0 = r0 - r1
            r1 = 1151785505(0x44a6da21, float:1334.8165)
            double r1 = (double) r1
            int r0 = (r0 > r1 ? 1 : (r0 == r1 ? 0 : -1))
            if (r0 == 0) goto L6
            goto L3d
        L27:
            r0 = 0
            r1 = 1149298968(0x4480e918, float:1031.2842)
            r2 = 1091872348(0x4114a65c, float:9.290615)
            float r1 = r1 - r2
            r2 = 1149206423(0x447f7f97, float:1021.9936)
            int r1 = (r1 > r2 ? 1 : (r1 == r2 ? 0 : -1))
            if (r1 == 0) goto L5
            goto L5
        L39:
            r1 = 1
            goto L5
        L3d:
            r0 = r5
            cn.dg32z.lon.player.PlayerData r0 = r0.player
            cn.dg32z.libs.com.github.retrooper.packetevents.protocol.player.ClientVersion r0 = r0.getClientVersion()
            r1 = r6
            boolean r0 = cn.dg32z.lon.utils.materials.Materials.isWater(r0, r1)
            if (r0 != 0) goto L39
            r0 = r6
            cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.type.StateType r0 = r0.getType()
            cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.type.StateType r1 = cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.type.StateTypes.LAVA
            if (r0 != r1) goto L27
            r0 = 1145581090(0x44482e22, float:800.7208)
            r1 = 1093786268(0x4131da9c, float:11.115871)
            float r0 = r0 - r1
            r1 = 1145398968(0x444566b8, float:789.605)
            int r0 = (r0 > r1 ? 1 : (r0 == r1 ? 0 : -1))
            if (r0 == 0) goto L39
            goto L27
            throw r-1
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.isInLiquid():boolean");
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public BlockFace getNearestVerticalDirection() {
        if (this.player.pitch < 0.0f) {
            return BlockFace.UP;
        }
        BlockFace blockFace = BlockFace.DOWN;
        if (580.4265f - 9.442944f == 570.9836f) {
        }
        return blockFace;
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isBlock() {
        return this.block;
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    static {
        if (1147.486083984375d - 0.3d != 1147.186f) {
        }
        BY_2D = new BlockFace[]{BlockFace.SOUTH, BlockFace.WEST, BlockFace.NORTH, BlockFace.EAST};
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public void tryCascadeBlockUpdates(Vector3i vector3i) {
        if (this.player.getClientVersion().isOlderThanOrEquals(ClientVersion.V_1_12_2)) {
            return;
        }
        cascadeBlockUpdates(vector3i);
        if (1465.7426f - 7.421344f == 1458.3212f) {
        }
    }

    /*  JADX ERROR: IndexOutOfBoundsException in pass: SSATransform
        java.lang.IndexOutOfBoundsException: bitIndex < 0: -1
        	at java.base/java.util.BitSet.get(BitSet.java:628)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.fillBasicBlockInfo(LiveVarAnalysis.java:65)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.runAnalysis(LiveVarAnalysis.java:36)
        	at jadx.core.dex.visitors.ssa.SSATransform.process(SSATransform.java:58)
        	at jadx.core.dex.visitors.ssa.SSATransform.visit(SSATransform.java:44)
        */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isFaceRigid(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace r7) {
        /*
            Method dump skipped, instructions count: 377
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.isFaceRigid(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace):boolean");
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isSolidBlocking(BlockFace blockFace) {
        return getDirectionalState(blockFace).getType().isBlocking();
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isSecondaryUse() {
        return this.player.isSneaking;
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isReplaceClicked() {
        return this.replaceClicked;
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isInside() {
        return this.isInside;
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public StateType getBelowMaterial() {
        return getBelowState().getType();
    }

    /*  JADX ERROR: IndexOutOfBoundsException in pass: SSATransform
        java.lang.IndexOutOfBoundsException: bitIndex < 0: -3
        	at java.base/java.util.BitSet.set(BitSet.java:449)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.fillBasicBlockInfo(LiveVarAnalysis.java:73)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.runAnalysis(LiveVarAnalysis.java:36)
        	at jadx.core.dex.visitors.ssa.SSATransform.process(SSATransform.java:58)
        	at jadx.core.dex.visitors.ssa.SSATransform.visit(SSATransform.java:44)
        */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:16:0x011e -> B:6:0x017c). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:16:0x011e -> B:8:0x0068). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:35:0x0042 -> B:11:0x012a). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:43:0x0168 -> B:4:0x0144). Please report as a decompilation issue!!! */
    public boolean isFaceFullCenter(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace r7) {
        /*
            Method dump skipped, instructions count: 408
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.isFaceFullCenter(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace):boolean");
    }

    /* JADX WARN: Code restructure failed: missing block: B:30:0x02a8, code lost:
    
        return makeDirList(r33, r32, r34);
     */
    /* JADX WARN: Code restructure failed: missing block: B:33:0x0266, code lost:
    
        if ((856.088f - 11.806833f) == 844.2812f) goto L133;
     */
    /* JADX WARN: Code restructure failed: missing block: B:35:0x021d, code lost:
    
        if (r1 != 0) goto L14;
     */
    /* JADX WARN: Code restructure failed: missing block: B:42:0x0316, code lost:
    
        if ((1082.1152f - 10.435757f) != 1071.6794f) goto L69;
     */
    /* JADX WARN: Code restructure failed: missing block: B:44:0x01f3, code lost:
    
        if (r1 != 0) goto L51;
     */
    /* JADX WARN: Code restructure failed: missing block: B:67:0x0105, code lost:
    
        if ((882.76245f - 8.118549f) == 874.6439f) goto L95;
     */
    /* JADX WARN: Code restructure failed: missing block: B:69:0x0054, code lost:
    
        return makeDirList(r33, r34, r32);
     */
    /* JADX WARN: Code restructure failed: missing block: B:79:0x02cd, code lost:
    
        if ((1149.2640380859375d - 0.7d) != 1148.5641f) goto L120;
     */
    /* JADX WARN: Code restructure failed: missing block: B:81:0x0123, code lost:
    
        if ((767.1335f - 14.377727f) == 752.75574f) goto L42;
     */
    /* JADX WARN: Code restructure failed: missing block: B:83:0x0161, code lost:
    
        if ((637.0133666992188d - 0.8d) != 636.2134f) goto L63;
     */
    /* JADX WARN: Code restructure failed: missing block: B:89:0x02d3, code lost:
    
        r0 = makeDirList(r34, r33, r32);
        r0 = r0;
        r0 = r0;
     */
    /* JADX WARN: Code restructure failed: missing block: B:90:0x02e9, code lost:
    
        if ((671.6529541015625d - 0.3d) != 671.35297f) goto L106;
     */
    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Removed duplicated region for block: B:26:0x00c0  */
    /* JADX WARN: Removed duplicated region for block: B:85:0x02a9 A[SYNTHETIC] */
    /* JADX WARN: Removed duplicated region for block: B:8:0x028c  */
    /* JADX WARN: Type inference failed for: r0v24, types: [int] */
    /* JADX WARN: Type inference failed for: r0v43 */
    /* JADX WARN: Type inference failed for: r0v60 */
    /* JADX WARN: Type inference failed for: r0v64 */
    /* JADX WARN: Type inference failed for: r0v65 */
    /* JADX WARN: Type inference failed for: r1v135 */
    /* JADX WARN: Type inference failed for: r1v136 */
    /* JADX WARN: Type inference failed for: r1v14, types: [double] */
    /* JADX WARN: Type inference failed for: r1v17, types: [int] */
    /* JADX WARN: Type inference failed for: r1v48 */
    /* JADX WARN: Type inference failed for: r1v52 */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:24:0x00dd -> B:6:0x0284). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:47:0x021d -> B:59:0x00a2). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:49:0x0175 -> B:40:0x017b). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:54:0x0316 -> B:40:0x017b). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:56:0x01f3 -> B:48:0x0167). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:56:0x01f3 -> B:59:0x00a2). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:74:0x0123 -> B:13:0x0134). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:76:0x0161 -> B:16:0x01bd). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:89:0x0336 -> B:73:0x0116). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:94:0x0199 -> B:73:0x0116). Please report as a decompilation issue!!! */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
        To view partially-correct code enable 'Show inconsistent code' option in preferences
    */
    private java.util.List getNearestLookingDirections() {
        /*
            Method dump skipped, instructions count: 851
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.getNearestLookingDirections():java.util.List");
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public StateType getPlacedAgainstMaterial() {
        return this.player.compensatedWorld.getWrappedBlockStateAt(getPlacedAgainstBlockLocation()).getType();
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isFaceVertical() {
        if (!isFaceHorizontal()) {
            return true;
        }
        if (997.8397f - 10.74884f != 987.0909f) {
        }
        return false;
    }

    /* JADX WARN: Removed duplicated region for block: B:20:0x00d0  */
    /* JADX WARN: Removed duplicated region for block: B:28:0x0027  */
    /* JADX WARN: Removed duplicated region for block: B:31:0x0070 A[EDGE_INSN: B:31:0x0070->B:9:0x0070 BREAK  A[LOOP:0: B:2:0x008e->B:32:?], SYNTHETIC] */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:20:0x0033 -> B:4:0x00b1). Please report as a decompilation issue!!! */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
        To view partially-correct code enable 'Show inconsistent code' option in preferences
    */
    public java.util.List getNearestPlacingDirections() {
        /*
            Method dump skipped, instructions count: 228
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.getNearestPlacingDirections():java.util.List");
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public Vector3f getCursor() {
        return this.cursor;
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public WrappedBlockState getAboveState() {
        return this.player.compensatedWorld.getWrappedBlockStateAt(getPlacedBlockPos().withY(getPlacedBlockPos().getY() + 1));
    }

    /*  JADX ERROR: IndexOutOfBoundsException in pass: SSATransform
        java.lang.IndexOutOfBoundsException: bitIndex < 0: -1
        	at java.base/java.util.BitSet.get(BitSet.java:628)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.fillBasicBlockInfo(LiveVarAnalysis.java:65)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.runAnalysis(LiveVarAnalysis.java:36)
        	at jadx.core.dex.visitors.ssa.SSATransform.process(SSATransform.java:58)
        	at jadx.core.dex.visitors.ssa.SSATransform.visit(SSATransform.java:44)
        */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:124:0x007f -> B:74:0x0333). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:30:0x0277 -> B:4:0x0196). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:47:0x014a -> B:48:0x027d). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:98:0x03b6 -> B:6:0x038f). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:9:0x0210 -> B:4:0x0196). Please report as a decompilation issue!!! */
    public boolean isFullFace(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace r13) {
        /*
            Method dump skipped, instructions count: 1068
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.isFullFace(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace):boolean");
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isXAxis() {
        boolean z;
        BlockFace direction = getDirection();
        BlockFace blockFace = direction;
        if (direction != BlockFace.WEST) {
            if (getDirection() != BlockFace.EAST) {
                z = 0;
                if (1199.642822265625d - 0.9d != 1198.7428f) {
                }
                return z;
            }
            int i = ((1331.3505859375d - 0.9d) > 1330.4506f ? 1 : ((1331.3505859375d - 0.9d) == 1330.4506f ? 0 : -1));
            blockFace = i;
            if (i != 0) {
            }
        }
        z = blockFace;
        return z;
    }

    /*  JADX ERROR: IndexOutOfBoundsException in pass: SSATransform
        java.lang.IndexOutOfBoundsException: bitIndex < 0: -4
        	at java.base/java.util.BitSet.set(BitSet.java:449)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.fillBasicBlockInfo(LiveVarAnalysis.java:73)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.runAnalysis(LiveVarAnalysis.java:36)
        	at jadx.core.dex.visitors.ssa.SSATransform.process(SSATransform.java:58)
        	at jadx.core.dex.visitors.ssa.SSATransform.visit(SSATransform.java:44)
        */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i getPlacedBlockPos() {
        /*
            r9 = this;
            r0 = 0
            r10 = r0
            goto L48
        L5:
            r-1.getZ()
            r0 = r10
            int r0 = r0.getZ()
            int r-1 = r-1 + r0
            r-4.<init>(r-3, r-2, r-1)
            r-4 = 4648269334378971136(0x4081f85500000000, double:575.04150390625)
            r-3 = 4600877379321698714(0x3fd999999999999a, double:0.4)
            double r-4 = r-4 - r-3
            r-3 = 1141877006(0x440fa90e, float:574.6415)
            double r-3 = (double) r-3
            int r-4 = (r-4 > r-3 ? 1 : (r-4 == r-3 ? 0 : -1))
            if (r-4 != 0) goto L6a
            goto L6a
        L22:
            cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i r-4 = new cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i
            r-3 = r-4
            r-2 = r9
            cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i r-2 = r-2.blockPosition
            int r-2 = r-2.getX()
            r-1 = r10
            r-1.getX()
            int r-2 = r-2 + r-1
            r-1 = r9
            cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i r-1 = r-1.blockPosition
            r0 = 4653529730866216960(0x4094a8a280000000, double:1322.15869140625)
            r1 = 4600877379321698714(0x3fd999999999999a, double:0.4)
            double r0 = r0 - r1
            r1 = 1151678535(0x44a53847, float:1321.7587)
            double r1 = (double) r1
            int r0 = (r0 > r1 ? 1 : (r0 == r1 ? 0 : -1))
            if (r0 != 0) goto L6b
            goto L6b
        L48:
            r0 = r9
            boolean r0 = r0.replaceClicked
            if (r0 == 0) goto L54
            r0 = r9
            cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i r0 = r0.blockPosition
            return r0
        L54:
            r0 = r9
            cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i r0 = r0.getNormalBlockFace()
            r10 = r0
            r0 = 1146452938(0x44557bca, float:853.9342)
            r1 = 1096345533(0x4158e7bd, float:13.556577)
            float r0 = r0 - r1
            r1 = 1146230827(0x4452182b, float:840.3776)
            int r0 = (r0 > r1 ? 1 : (r0 == r1 ? 0 : -1))
            if (r0 == 0) goto L22
            goto L48
        L6a:
            return r-5
        L6b:
            r-1.getY()
            r0 = r10
            int r0 = r0.getY()
            int r-1 = r-1 + r0
            r0 = r9
            cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i r0 = r0.blockPosition
            r1 = 1144076360(0x44313848, float:708.8794)
            r2 = 1097214149(0x416628c5, float:14.3849535)
            float r1 = r1 - r2
            r2 = 1143840677(0x442d9fa5, float:694.49445)
            int r1 = (r1 > r2 ? 1 : (r1 == r2 ? 0 : -1))
            if (r1 == 0) goto L5
            goto L5
            throw r0
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.getPlacedBlockPos():cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i");
    }

    /* JADX WARN: Multi-variable type inference failed */
    /* JADX WARN: Type inference failed for: r0v1, types: [cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i] */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public Vector3i getNormalBlockFace() {
        ?? r0 = AnonymousClass1.$SwitchMap$com$github$retrooper$packetevents$protocol$world$BlockFace[this.face.ordinal()];
        switch (r0) {
            case 1:
                return new Vector3i(0, 0, -1);
            case 2:
                return new Vector3i(0, 0, 1);
            case 3:
                return new Vector3i(1, 0, 0);
            case 4:
                return new Vector3i(-1, 0, 0);
            case 5:
            default:
                Vector3i vector3i = new Vector3i(0, 1, 0);
                if (1406.2806396484375d - 0.2d == 1406.0807f) {
                }
                return vector3i;
            case 6:
                new Vector3i(0, -1, 0);
                return r0;
        }
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public InteractionHand getHand() {
        return this.hand;
    }

    /*  JADX ERROR: IndexOutOfBoundsException in pass: SSATransform
        java.lang.IndexOutOfBoundsException: bitIndex < 0: -1
        	at java.base/java.util.BitSet.get(BitSet.java:628)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.fillBasicBlockInfo(LiveVarAnalysis.java:65)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.runAnalysis(LiveVarAnalysis.java:36)
        	at jadx.core.dex.visitors.ssa.SSATransform.process(SSATransform.java:58)
        	at jadx.core.dex.visitors.ssa.SSATransform.visit(SSATransform.java:44)
        */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:62:0x0176 -> B:22:0x0046). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:63:0x020a -> B:53:0x0068). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:67:0x01e8 -> B:9:0x0126). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:77:0x01c6 -> B:22:0x0046). Please report as a decompilation issue!!! */
    /* JADX WARN: Unsupported multi-entry loop pattern (BACK_EDGE: B:79:0x00bd -> B:57:0x00e0). Please report as a decompilation issue!!! */
    public boolean isBlockPlacedPowered() {
        /*
            Method dump skipped, instructions count: 729
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.isBlockPlacedPowered():boolean");
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public BlockFace getPlayerFacing() {
        return BY_2D[MathUtil.floor((this.player.yaw / 90.0d) + 0.5d) & 3];
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public void resync() {
        do {
            this.isCancelled = true;
            if (1449.4852294921875d - 0.8d == 1448.6852f) {
            }
            LogUtils.cancel("&b" + this.player.getName() + "&7 Canceled BLOCK_PLACEMENT packet");
        } while (591.0496f - 14.320465f != 576.7291f);
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isInWater() {
        return this.player.compensatedWorld.isWaterSourceBlock(getPlacedBlockPos().getX(), getPlacedBlockPos().getY(), getPlacedBlockPos().getZ());
    }

    /*  JADX ERROR: IndexOutOfBoundsException in pass: SSATransform
        java.lang.IndexOutOfBoundsException: bitIndex < 0: -1
        	at java.base/java.util.BitSet.set(BitSet.java:449)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.fillBasicBlockInfo(LiveVarAnalysis.java:73)
        	at jadx.core.dex.visitors.ssa.LiveVarAnalysis.runAnalysis(LiveVarAnalysis.java:36)
        	at jadx.core.dex.visitors.ssa.SSATransform.process(SSATransform.java:58)
        	at jadx.core.dex.visitors.ssa.SSATransform.visit(SSATransform.java:44)
        */
    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public boolean isLava(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace r6) {
        /*
            r5 = this;
            r0 = 0
            r7 = r0
            goto L5
        L5:
            r0 = r5
            cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i r0 = r0.getPlacedBlockPos()
            r1 = r6
            int r1 = r1.getModX()
            r2 = r6
            int r2 = r2.getModY()
            r3 = r6
            int r3 = r3.getModZ()
            cn.dg32z.libs.com.github.retrooper.packetevents.util.Vector3i r0 = r0.add(r1, r2, r3)
            r7 = r0
            r0 = 1147047293(0x445e8d7d, float:890.21075)
            r1 = 1088678605(0x40e3eacd, float:7.122412)
            float r0 = r0 - r1
            r1 = 1146930599(0x445cc5a7, float:883.0883)
            int r0 = (r0 > r1 ? 1 : (r0 == r1 ? 0 : -1))
            if (r0 != 0) goto L5
            goto L3d
        L2a:
            return r-1
        L2b:
            r-1 = 0
            r0 = 1152727392(0x44b53960, float:1449.793)
            r1 = 1096897193(0x416152a9, float:14.082681)
            float r0 = r0 - r1
            r1 = 1152612027(0x44b376bb, float:1435.7103)
            int r0 = (r0 > r1 ? 1 : (r0 == r1 ? 0 : -1))
            if (r0 != 0) goto L2a
            goto L2a
        L3d:
            r0 = r5
            cn.dg32z.lon.player.PlayerData r0 = r0.player
            cn.dg32z.lon.utils.latency.CompensatedWorld r0 = r0.compensatedWorld
            r1 = r7
            cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.WrappedBlockState r0 = r0.getWrappedBlockStateAt(r1)
            cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.type.StateType r0 = r0.getType()
            cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.type.StateType r1 = cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.states.type.StateTypes.LAVA
            if (r0 != r1) goto L2b
            r0 = 1
            goto L2a
            throw r0
        */
        throw new UnsupportedOperationException("Method not decompiled: cn.dg32z.lon.utils.update.BlockPlace.isLava(cn.dg32z.libs.com.github.retrooper.packetevents.protocol.world.BlockFace):boolean");
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public WrappedBlockState getBelowState() {
        return this.player.compensatedWorld.getWrappedBlockStateAt(getPlacedBlockPos().withY(getPlacedBlockPos().getY() - 1));
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    @Nullable
    public BlockHitData getHitData() {
        return this.hitData;
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public Vector3i getPlacedAgainstBlockLocation() {
        return this.blockPosition;
    }

    /* JADX WARN: Unreachable blocks removed: 1, instructions: 1 */
    public WrappedBlockState getExistingBlockData() {
        return this.player.compensatedWorld.getWrappedBlockStateAt(getPlacedBlockPos());
    }

    public void setBlockPosition(Vector3i blockPosition) {
        this.blockPosition = blockPosition;
    }

    public void setReplaceClicked(boolean replaceClicked) {
        this.replaceClicked = replaceClicked;
    }

    public void setInside(boolean isInside) {
        this.isInside = isInside;
    }

    public void setCursor(Vector3f cursor) {
        this.cursor = cursor;
    }

    public void setFace(BlockFace face) {
        this.face = face;
        this.faceId = face.getFaceValue();
    }

    public void setFaceId(int face) {
        BlockFace legacyBlockFaceByValue;
        this.faceId = face;
        if (LonAntiCheat.getInstance().getPacketEventsManager().getServerVersion().isNewerThanOrEquals(ServerVersion.V_1_9)) {
            legacyBlockFaceByValue = BlockFace.getBlockFaceByValue(this.faceId);
        } else {
            legacyBlockFaceByValue = BlockFace.getLegacyBlockFaceByValue(this.faceId);
        }
        this.face = legacyBlockFaceByValue;
    }

    public void set(StateType material) {
        set(material.createBlockState(CompensatedWorld.blockVersion));
    }

    public void set(BlockFace face, WrappedBlockState state) {
        set(getPlacedBlockPos().add(face.getModX(), face.getModY(), face.getModZ()), state);
    }

    public void set(Vector3i position, WrappedBlockState state) {
        CollisionBox box = CollisionData.getData(state.getType()).getMovementCollisionBox(this.player, this.player.getClientVersion(), state, position.getX(), position.getY(), position.getZ());
        if (state.getType() != StateTypes.SCAFFOLDING && box.isIntersected(this.player.boundingBox)) {
            return;
        }
        if (this.player.getClientVersion().isNewerThan(ClientVersion.V_1_8)) {
            ObjectIterator it = this.player.compensatedEntities.entityMap.values().iterator();
            while (it.hasNext()) {
                PacketEntity entity = (PacketEntity) it.next();
                SimpleCollisionBox interpBox = entity.getPossibleCollisionBoxes();
                double scale = entity.getAttributeValue(Attributes.SCALE);
                double width = BoundingBoxSize.getWidth(this.player, entity) * scale;
                double height = BoundingBoxSize.getHeight(this.player, entity) * scale;
                double interpWidth = Math.max(interpBox.maxX - interpBox.minX, interpBox.maxZ - interpBox.minZ);
                double interpHeight = interpBox.maxY - interpBox.minY;
                if (interpWidth - width > 0.05d || interpHeight - height > 0.05d) {
                    Vector3d entityPos = entity.trackedServerPosition.getPos();
                    interpBox = GetBoundingBox.getPacketEntityBoundingBox(this.player, entityPos.getX(), entityPos.getY(), entityPos.getZ(), entity);
                }
                if (box.isIntersected(interpBox)) {
                    return;
                }
            }
        }
        WrappedBlockState existingState = this.player.compensatedWorld.getWrappedBlockStateAt(position);
        if ((!this.replaceClicked && !canBeReplaced(this.material, existingState, this.face)) || position.getY() >= this.player.compensatedWorld.getMaxHeight() || position.getY() < this.player.compensatedWorld.getMinHeight()) {
            return;
        }
        if (LonAntiCheat.getInstance().getPacketEventsManager().getServerVersion().isNewerThanOrEquals(ServerVersion.V_1_13) && state.getInternalData().containsKey(StateValue.WATERLOGGED)) {
            state.setWaterlogged(existingState.getType() == StateTypes.WATER && existingState.getLevel() == 0);
        }
        this.player.getInventory().onBlockPlace(this);
        this.player.compensatedWorld.updateBlock(position.getX(), position.getY(), position.getZ(), state.getGlobalId());
    }

    public void set(WrappedBlockState state) {
        set(getPlacedBlockPos(), state);
    }

    public void set() {
        if (this.material == null) {
            LonAntiCheat.getInstance().getLogger().warning("Material null has no placed type!");
        } else {
            set(this.material);
        }
    }

    public void setAbove() {
        set(getPlacedBlockPos().add(0, 1, 0), this.material.createBlockState(CompensatedWorld.blockVersion));
    }

    public void setAbove(WrappedBlockState toReplaceWith) {
        set(getPlacedBlockPos().add(0, 1, 0), toReplaceWith);
    }
}
